/**
 * @author manager
 */
$.fn.extend({
	el : function(tag,content,attributes){
		var element='<'+tag;
		if (attributes) for (var a in attributes){
			element+=' '+a+'="'+attributes[a]+'"';
		}
		element+=(content&&content.length)?('>'+content+'</'+tag+'>'):'/>';
		element = $(element);
		this.append(element);
		return element;
	},
	autoheight : function(max){return this.each(function(){new autoheight(this,max);});},
	autowidth : function(max){return this.each(function(){new autowidth(this,max);});},
	wmark : function(text){return this.each(function(){new wmark(this,text);});},
	combo : function(props){return this.each(function(){new combo(this,props);});},
	serializeAssoc : function(){
		var json = {};
		this.each(function(i,elem){
			if (!(elem.name in json)) json[elem.name] = $(this).val();
			else json[elem.name] += $(this).val();
		});
		var str = '';
		for (var i in json){
			str+='&'+i+'='+json[i];
		}
		return str;
	},
	serializeJqtJSON : function(){
		var json = {};
		this.each(function(i,elem){
			if (!(elem.name in json)) json[elem.name] = $(this).val();
			else json[elem.name] += $(this).val();
		});
		return json;
	},
	timer : function(time,action){return new spanTimer(this,time,action);},
	visibility : function(visible){
		visible?this.show():this.hide();
		return this;
	},
	center : function(){
		var ow = this.width()+parseInt(this.css('padding-left'))+parseInt(this.css('padding-right'));
		var oh = this.height()+parseInt(this.css('padding-top'))+parseInt(this.css('padding-bottom'));
		var w = ($(window).width()>ow)?($(window).width()-ow)/2:0;
		var h = ($(window).height()>oh)?($(window).height()-oh)/2:0;
		this.css({left:w+'px',top:h+'px'});
		$('body').scrollTop(0);
	}
});
function spanTimer(o,time,action){
	var t=parseInt(time);
	function zero(i){
		return (i<10)?'0'+i:''+i;
	}
	var h = function(){
		o.html((Math.floor(t/60)) + ':' + zero(t%60));
		if (t<1){
			clearInterval(i); action();
		} else {
			t-=1;
		}
	}
	var i;
	this.start = function(){
		h(); i = setInterval(h,1000);
	}
	this.stop = function(){
		clearInterval(i);
	}
	return this;
};
function wmark(e,text){
	this.input = $(e);
	this.input.parent().el('div',text,{'class':'wmark'}).css({
		'line-height': this.input.css('line-height'),
		'text-align' : this.input.css('text-align'),
		'margin-left' : '1px',
		width : this.input.css('width'),
		height : this.input.css('line-height'),
		'padding-left' : this.input.css('padding-left'),
		'padding-right' : this.input.css('padding-right')
	}).insertBefore(this.input);
	this.input.css({'background-color':'transparent'}).focus(function(){
		$(this).css({'background-color':'#ffffff'});
	}).blur(function(){
		if ($(this).val()=='') $(this).css({'background-color':'transparent'});
	})
};
function combo(e,props){
	var t = this;
	this.filter = props.filter||function(l){return true;};
	this.inserter = props.inserter||function(l){return l;};
	this.hidden = props.hidden||function(l){return false;};
	if (typeof(props.list)=='function') this.list = props.list;
	else if (typeof(props.list)=='object') {
		this.llist = props.list;
		this.list = function(){return t.llist};
	};
	this.flist = [];
	this.vassal = props.vassal;
	this.selected = -1;
	this.input = $(e).addClass('combo-input');
	this.div = $('body').el('div').addClass('widthdiv');
	this.wrapper = this.input.parent().el('div','',{'class':'combo'}).css({
		'text-align': 'left',
		'margin-left': this.input.css('margin-left')
	}).hide();
	this.switchKey = function(e){
		switch(e.which){
			case 40: case 39: {t.next(); return false;} break;
			case 37: case 38: {t.prev(); return false;} break;
			case 34: case 35: {t.last(); return false;} break;
			case 33: case 36: {t.first(); return false;} break;
			case 13: case 27: {t.input.blur(); return false;} break;
			case 9: break;
			default: {t.input.select(); return false;} break;
		}	
	};
	this.first = function(){
		$('#'+t.input.attr('id')+0).mouseover();
	};
	this.last = function(){
		$('#'+t.input.attr('id')+(t.flist.length-1)).mouseover();
	};
	this.next = function(){
		if (t.selected>=0) $('#'+t.input.attr('id')+((t.selected+1)%t.flist.length)).mouseover();
		else t.first();
	};
	this.prev = function(){
		if (t.selected>=0) $('#'+t.input.attr('id')+(t.flist.length+t.selected-1)%t.flist.length).mouseover();
		else t.last();
	};
	this.input.focus(function(){
		t.flist = [];
		var list = t.list();
		t.width = t.input.width();
		$.each(list, function(){
			if (t.filter(this)) {
				t.flist.push(this);
				t.div.html(t.inserter(this));
				//debug('div: w'+t.div.width()+' i'+t.div.innerWidth()+' o'+t.div.outerWidth()+' c'+t.div.css('width'));
				//debug('input: w'+t.input.width()+' i'+t.input.innerWidth()+' o'+t.input.outerWidth()+' c'+t.input.css('width'));
				if (t.div.width()>t.input.width() && t.div.width()>t.width) t.width = t.div.width();
			}
		});
		var exists = false;
		var l;
		for (var i=0; i<t.flist.length; i++){
			l = t.flist[i];
			t.wrapper.css({
				width : Math.max(t.width,t.input.width())+parseInt(t.input.css('padding-left'))+parseInt(t.input.css('padding-right'))+'px',
				top : t.input.position().top+t.input.outerHeight()+'px',
				left : t.input.position().left-1+'px'
			});
			var d = t.wrapper.el('div', t.inserter(l),{id:t.input.attr('id')+i}).hover(function(e){
				var da = $(e.target);
				t.selected = parseInt(da.attr('id').split(t.input.attr('id'))[1]);
				t.wrapper.children().removeClass('active');
				da.addClass('active');
				t.input.val(da.html()).select();
				t.hidden(t.flist[t.selected]);
			}, function(e){
				$(e.target).removeClass('active');
			}).css({width : t.wrapper.width()-parseInt(t.input.css('padding-left'))-parseInt(t.input.css('padding-right'))+'px'});
			if ((t.input.val() != '') && (t.inserter(l)==t.input.val())){//Тут была коварная ошибка. Равенство и indexOf = это две большие разницы же
				d.addClass('active'); exists = true; t.selected = i;
				t.hidden(t.flist[t.selected]);//И вот это нужно, если значение по умолчанию установлено
			}
		};
		if (!exists) {t.input.val(''); t.hidden(); t.selected = -1;};
		t.wrapper.show();
	}).blur(function(){
		t.wrapper.empty().hide();
		if (t.vassal) {
			if (t.input.val() != '') {
				$('#' + t.vassal).parent().show();
				$('#' + t.vassal).focus();
			} else $('#' + t.vassal).parent().hide();
		};
	}).click(function(){t.input.select(); return false;})
	.keydown(t.switchKey);
};
function autoheight(e,max)
{
	this.lineHeight = parseInt($(e).css('line-height'));
	this.textarea = $(e);
	this.textarea.css({overflow: 'hidden', display: 'block',height: this.lineHeight*2 + 'px'});
	this.div = $('body').el('div').css({
		'font-size': this.textarea.css('font-size'),
		'font-family': this.textarea.css('font-family'),
		'width': this.textarea.css('width'),
		'padding': this.textarea.css('padding'),
		'line-height': this.lineHeight + 'px',
		'overflow-x' : 'hidden',
		'position' : 'absolute',
		'display' : 'none'
	});
	this.max = max;
	var t = this;
	var tcE = function(e){t.checkExpand(e);}
	this.textarea.focus(function(){t.textarea.keyup(tcE);});
	this.textarea.blur(function(){t.checkExpand(e);t.textarea.unbind('keyup',tcE);});
	this.checkExpand = function(e) {
		var html = this.textarea.val().replace(/(<|>)/g, '').replace(/\n/g, '<br/>');
		if (this.div.html() != html)
		{
			this.div.html(html);
			this.textarea.css('overflow-y', 'hidden');
			if (this.textarea.height() < this.div.height() + this.lineHeight || this.div.height() < this.textarea.height())
			{
				this.textarea.height(this.div.height() + this.lineHeight);
			}
			if (this.max&&this.textarea.height()>this.max) this.textarea.height(this.max);
		}
	};
};
function autowidth(e,max)
{
	this.charWidth = parseInt($(e).css('font-size'));
	this.input = $(e);
	this.input.width(this.charWidth*2.4);
	this.div = $('body').el('div').css({
		'font-size': this.input.css('font-size'),
		'font-family': this.input.css('font-family'),
		'padding': this.input.css('padding'),
		'position' : 'absolute',
		'display' : 'none'
	});
	this.max = max;
	var t = this;
	var tcE = function(e){t.checkExpand(e);}
	this.input.focus(function(){t.input.keyup(tcE);});
	this.input.blur(function(){t.checkExpand(e);t.input.unbind('keyup',tcE);});
	this.checkExpand = function(e) {
		var html = this.input.val().replace(/(<|>)/g, '');
		if (this.div.html() != html)
		{
			this.div.html(html);
			if (this.input.width() < (this.div.width() + this.charWidth*1.2) || this.div.width() < this.input.width())
			{
				this.input.width(this.div.width() + this.charWidth*1.2);
			}
			if (this.max&&this.input.width()>this.max) this.input.width(this.max);
		}
	};
};