/**
 * @author manager
 */
var mode;
function Mode(header,hintText,hintLink,hintAction,buttonText,buttonAction){
	this.header = header;
	this.hintText = hintText;
	this.hintLink = hintLink;
	this.hintAction = hintAction;
	this.buttonText = buttonText;
	this.buttonAction = buttonAction;
}
function Field(id,type,modes,vis,text,props,combo,listeners){
	this.id = id;
	this.type = type;
	this.modes = modes||[];
	this.vis = vis||false;
	this.text = text||'';
	this.props = props||{};
	this.combo = combo||false;
	this.listeners = listeners||{};
};
var fields = [
	new Field('lastname','text',['reg'],true,'Фамилия',{maxlength:100,minlength:1}),
	new Field('firstname','text',['reg'],true,'Имя',{maxlength:100,minlength:1}),
	new Field('secondname','text',['reg'],true,'Отчество',{maxlength:100,minlength:1}),
	new Field('group','text',['reg'],true,'Группа',{maxlength:100,minlength:1},{
		list:function(){return db.groups;},
		inserter:function(l){return l.group;},
		hidden:function(l){$('#group_id').val(l?l.id:'');}
	}),
	new Field('group_id','hidden',['reg']),
	new Field('login','text',['auth','reg'],true,'Логин',{maxlength:30,minlength:6}),
	new Field('password','password',['auth','reg'],true,'Пароль',{maxlength:32,minlength:6}),
	new Field('subjects','text',['select'],true,'Выберите предмет',{maxlength:200,minlength:1},{
		list:function(){return db.subjects;},
		inserter:function(l){return l.subject;},
		hidden:function(l){$('#subject_id').val(l?l.id:'');},
		vassal:'tests'
	}),
	new Field('subject_id','hidden',['select']),
	new Field('tests','text',['select'],false,'Выберите тест',{maxlength:200,minlength:1},{
		list:function(){return db.tests;},
		inserter:function(l){return l.test;},
		filter:function(l){return l.subject_id==$('#subject_id').val();},
		hidden:function(l){$('#test_id').val(l?l.id:'');},
		vassal:'submitbutton'
	}),
	new Field('test_id','hidden',['select']),
	new Field('addition','button',['mark'],false,'',{value:'Продолжить тестирование'},false,{click:sendAddition})
];
var modes = {
	auth: new Mode('Авторизация','Нет логина? ','Зарегистрируйтесь!',function(){$('#error').hide();
		$.ajax({data:'mode=groups',success:function(r){db.groups=r.groups;showMode('reg');}});
	},'Войти в систему',sendAuth),
	reg: new Mode('Регистрация','Уже есть логин? ','Авторизуйтесь!',function(){$('#error').hide();
		$('#submitbutton').parent().show();showMode('auth');},'Зарегистрироваться',sendAuth),
	select: new Mode('Выбор теста','Стало страшно? ','Есть выход!',function(){
		showMode('auth');
		$('#submitbutton').parent().show();
	},'Начать тестирование',sendSelect),
	test: new Mode('Тестирование','Надоело? ','Завершите тест!',function(){
		$.ajax({data:'mode=finish',success: function(r){question(r);}});
	},'Отправить ответ',sendAnswer),
	mark: new Mode('Выставление отметки','Всё плохо? ','Есть выход!',function(){
		showMode('auth');
	},'Вернуться к выбору теста',finish)
};
function sendAuth(){
	$('#submitbutton').parent().hide();
	$('#message').html('Соединение с сервером...').show();
	var valid = true;
	for (var i = 0; i < fields.length; i++) {
		if ($.inArray(mode, fields[i].modes) != -1) valid = validate($('#' + fields[i].id));
		if (!valid) break;
	}
	if (valid) $.ajax({data:$.extend($('.holder>:input').serializeJqtJSON(),{mode:mode}),success: function(r){select(r);}});
	else $('#message').hide();
	return false;
};
function sendSelect(){
	$('#submitbutton').parent().hide();
	$('#message').html('Соединение с сервером...').show();
	db.subject = $('#subject_id').val();
	$.ajax({data:$(':input').serialize()+'&mode='+mode,success: function(r){question(r);}});
	return false;
};
function sendAnswer(){
	$('#submitbutton').parent().hide();
	$('#message').html('Соединение с сервером...').show();
	//debug($('[id^="_"]').serializeAssoc());
	//$.ajax({data:'&mode='+mode+$('[id^="_"]').serializeAssoc(),success: function(r){question(r);}});
	//alert(JSON.stringify($('[id^="_"]').serializeJqtJSON()));
	$.ajax({data:{mode:mode,help_used:db.help_used,answer:JSON.stringify($('[id^="_"]').serializeJqtJSON())},success: function(r){question(r);}});
	return false;
};
function sendAddition(){
	$('#submitbutton').parent().hide();
	$('#message').html('Соединение с сервером...').show();
	$.ajax({data:{mode:'test',addition:true},success: function(r){question(r);}});
	return false;
};
function finish(){
	$('#submitbutton').parent().hide();
	showMode('select');
	return false;
};
function showMode(m){
	var div = $('#form_content').empty();
	mode = m;
	//debug(mode);
	with(modes[mode]){
		$('#header').html(header);
		$('#hint').html(hintText).el('a',hintLink,{href:'#'}).click(hintAction);
		$('#submitbutton').val(buttonText);
		form.unbind('submit').submit(buttonAction);
	}
	var f;
	$.each(fields,function(i,field){
		with (field) {
			if ($.inArray(mode,this.modes)!=-1){
				f = div.el('div','',{'class':'holder'}).el('input','',$.extend({type:type,name:id,id:id},props));
				if (combo) f.combo(combo);
				if (text.length) f.wmark(text);
				f.parent().visibility(vis);
				for (var ev in listeners) {f.bind(ev,listeners[ev]);};
			}
		}
	});
	$('#error').hide();
	addBrowserCSS();
	$('#content').center();
};
function addBrowserCSS(){
	if (!air){
		$('input').hover(function(){$(this).css({'border': '1px solid #75bef0'});},
		function(){$(this).css({'border': '1px solid #c9cbcc'});})
		.focus(function(){$(this).css({'border': '1px solid #75bef0'});})
		.blur(function(){$(this).css({'border': '1px solid #c9cbcc'});})
		.css({'border': '1px solid #c9cbcc'});
		$('input').not(':checkbox').not(':radio').not('textarea').height('24px');
		$(':button').css({'background-color':'#ececec','height':'28px'});
	}
}