/**
 * @author manager
 */
var types = {
	caption:function(holder,content){
		holder.el('h4',resolveMediaPath(content),{'class':'grey'});
	},
	text:function(holder,content){
		holder.el('p',resolveMediaPath(content));
	},
	help:function(holder,content){
		if (db.use_help){
			holder.el('a','Помощь',{'class':'help-link'}).click(function(){
				$(this).siblings('div.help').toggle();
				db.help_used = true;		
			});
			holder.el('div',resolveMediaPath(content),{'class':'help',style:'display:none;'});
		}
	},
	note:function(holder,content){
		holder.el('p',resolveMediaPath(content),{'class':'note'});
	},
	checkboxgroup:function(holder,content,qdb){
		var l,jid;
		var variants = shuffleVariants(content.labels);
		$.each(variants,function(j,variant){
			l = holder.el('div','',{'class':'label'}).el('label');
			jid = '_'+content.id+'_'+variant.id;
			var inp = l.el('input','',{type:'checkbox',name:jid,id:jid,value:'','class':'alt'}).click(function(e){
				$('[id^="_'+content.id+'"]').each(function(i,elem){
					$(elem).val(elem.checked?"1":"0");
				});
			});
			l.append(resolveMediaPath(variant.label));
			if (qdb){
				var a;
				if (qdb.answer&&(a = qdb.answer[jid])){
				inp.val(a).attr('checked',(inp.val()=='1'));
				}
				if (qdb.right_answer&&(a = qdb.right_answer[jid])){
					inp.attr({disabled:'disabled'});
					if (inp.val()==a) l.el('img','',{'class':'correct',src:'lib/images/accept.png'});
					else l.el('img','',{'class':'correct',src:'lib/images/exclamation.png'});
				}
			}
		});
	},
	radiogroup:function(holder,content,qdb){
		var l,rad;
		var variants = shuffleVariants(content.labels);
		var inp = holder.el('input','',{type:'hidden',value:'',name:'_'+content.id,id:'_'+content.id});
		$.each(variants,function(j,variant){
			l = holder.el('div','',{'class':'label'}).el('label');
			rad = l.el('input','',{type:'radio',name:'radio_'+content.id,id:'radio_'+content.id+'_'+variant.id,'class':'alt'}).click(radioValue);
			l.append(resolveMediaPath(variant.label));
			inp.val(inp.val()+'0');
			if (qdb){
				var a;
				if (qdb.answer&&(a = qdb.answer['_'+content.id])){
					rad.val(a.charAt(variant.id)).attr('checked',(rad.val()=='1'));
				};
				if (qdb.right_answer&&(a = qdb.right_answer['_'+content.id])){
					rad.attr({disabled:'disabled'});
					if (a.charAt(variant.id)=='1'){
						if (rad.val()==a.charAt(variant.id)) l.el('img','',{'class':'correct',src:'lib/images/accept.png'});
						else {
							l.el('img','',{'class':'correct',src:'lib/images/exclamation.png'});
							l.el('img','',{'class':'correct',src:'lib/images/arrow_left.png'});
						}
					} else {
						if (rad.val()!=a.charAt(variant.id)) l.el('img','',{'class':'correct',src:'lib/images/exclamation.png'});
					}
				}
			}
		});
	},
	input:function(holder,content,qdb){
		var inp = holder.el('div').el('label',resolveMediaPath(content.label)).el('input','',{type:'text',name:'_'+content.id,id:'_'+content.id});
		inp.autowidth(600);
		if (qdb){
			var a;
			if (qdb.answer&&(a = qdb.answer['_'+content.id])){inp.val(a).blur()};
			if (qdb.right_answer&&(a = qdb.right_answer['_'+content.id])) {
				inp.attr({disabled:'disabled'})
				if (inp.val()==a) inp.parent().el('img','',{'class':'correct',src:'lib/images/accept.png'});
				else {
					inp.parent().el('img','',{'class':'correct',src:'lib/images/exclamation.png'});
					var nobr = inp.parent().el('nobr');
					nobr.el('img','',{'class':'correct',src:'lib/images/arrow_right.png'});
					nobr.el('span',a,{'class':'inactive'});
				}
			}
		}
	},
	textarea:function(holder,content,qdb){
		var txa = holder.el('div').el('label',resolveMediaPath(content.label))
		.el('textarea','',{name:'_'+content.id,id:'_'+content.id});
		txa.autoheight(400);
		if (qdb){
			var a;
			if (qdb.answer&&(a = qdb.answer['_'+content.id])){txa.text(a).blur()};
			if (qdb.right_answer&&(a = qdb.right_answer['_'+content.id])) {
				txa.attr({disabled:'disabled'})
				if (txa.text()==a) txa.parent().el('img','',{'class':'correct',src:'lib/images/accept.png'});
				else {
					txa.parent().el('img','',{'class':'correct',src:'lib/images/exclamation.png'});
					txa.parent().el('br','',{'class':'clear'});
					txa.parent().el('img','',{'class':'correct',src:'lib/images/arrow_down.png'});
					txa.parent().el('div',a,{'class':'inactive'});
				}
			}
		}
	},
	select:function(holder,content,qdb){
		var hid = holder.el('input','',{type:'hidden',name:'_'+content.id,id:'_'+content.id});
		var options = shuffleVariants(content.options);
		var inp = holder.el('div').el('label',resolveMediaPath(content.label)).el('span','',{'class':'holder'})
		.el('input','',{type:'text',name:'sel_'+content.id,id:'sel_'+content.id})
		inp.autowidth(600).combo({
			list: options,
			inserter: function(l){return l.label;},
			hidden: function(l){$('#_'+content.id).val(l ? l.id : '');}
		});
		if (qdb){
			var a;
			if (qdb.answer&&(a = qdb.answer['_'+content.id])){
				inp.val(options[a].label).focus().blur();
			};
			if (qdb.right_answer&&(a = qdb.right_answer['_'+content.id])) {
				inp.attr({disabled:'disabled'})
				if (inp.val()==options[a].label) inp.parent().el('img','',{'class':'correct',src:'lib/images/accept.png'});
				else {
					inp.parent().el('img','',{'class':'correct',src:'lib/images/exclamation.png'});
					var nobr = inp.parent().el('nobr');
					nobr.el('img','',{'class':'correct',src:'lib/images/arrow_right.png'});
					nobr.el('span',options[a].label,{'class':'inactive'});
				}
			}
		}
	},
	matchgroup:function(holder,content,qdb){
		var jid,tr,td;
		$.each(content.labels,function(j,e){
			tr = holder.el('table','',{'class':'match'}).el('tbody').el('tr');
			jid = '_'+content.id+'_'+j;
			tr.el('td',resolveMediaPath(e));
			td = tr.el('td');
			td.el('input','',{type:'hidden',name:jid,id:jid});
			if (qdb && ('right_answer' in qdb)) td.el('div','?',{'class':'inactive',id:'slot'+jid});
			else td.el('div','?',{'class':'empty',id:'slot'+jid}).droppable(dropProps('_'+content.id));
		});
	},
	variants:function(holder,content,qdb){
		var div = holder.el('div','',{'class':'variants'});
		var v;
		var variants = shuffleVariants(content.elements);
		$.each(variants,function(j,variant){
			v = div.el('div','',{'class':'variant'}).el('div',resolveMediaPath(variant.label),{id:'variant_'+content.id+'_'+variant.id});
			if (qdb && ('right_answer' in qdb)) v.parent().removeClass('variant').addClass('inactive-variant');
			else v.draggable({revert:true, helper:'clone', opacity:0.5});
			if (qdb && qdb.answer){
				var kid;
				for (var k=0; k<10; k++){
					kid = '_'+content.id+'_'+k;
					if (qdb.answer[kid]==variant.id.toString()){
						if ('right_answer' in qdb) $('#slot'+kid).empty().append(v.html());
						else $('#slot'+kid).removeClass('empty').addClass('filled')
							.empty().append(v.html()).click(discardChoice);
						v.parent().hide();
						$('#'+kid).val(variant.id);
					}
				}
			}
			if (qdb && qdb.right_answer){
				var kid,tr,td;
				for (var k=0; k<10; k++){//Магическое число)
					kid = '_'+content.id+'_'+k;
					if (qdb.right_answer[kid]==variant.id.toString()){
						tr = $('#slot'+kid).parent().parent();
						td = $('#slot'+kid).parent();
						if ($('#'+kid).val()==variant.id.toString()) tr.el('td').insertAfter(td).el('img','',{'class':'correct',src:'lib/images/accept.png'});
						else {
							var ttd = tr.el('td').insertAfter(td);
							ttd.el('img','',{'class':'correct',src:'lib/images/exclamation.png'});
							ttd.el('img','',{'class':'correct',src:'lib/images/arrow_right.png'});
							tr.el('td').insertAfter(ttd).el('div','',{'class':'inactive'}).append(v.html());
						}
					}
				}
			}
		});
	}
};
function radioValue(){
	var cid = getID(this)[1];
	var checks = [];
	$('[id^="radio_'+cid+'"]').each(function(i,elem){
		checks[getID(elem)[2]]=elem.checked?'1':'0';
	});
	$('#_'+cid).val(checks.join(''));
}
function shuffleVariants(a){
	for (var i=0,s=[],ri; i<a.length; i++){
		ri = Math.round(Math.random()*s.length);
		s.splice(ri,0,{id:i,label:a[i]});
	}
	return s;
}
function resolveMediaPath(s){
	return s.replace(/%mediapath%/g,mediapath+'subject'+db.subject).replace(/%ms(-?[\d]*)%([^%]*)%me%/g,
	'<img class="formula" style="top: $1px" src="'+rendererpath+'mimetex.cgi?\\Large $2" />');
}
function discardChoice(){
	var id = getID(this);
	$(this).empty().append('?');
	$(this).removeClass('filled');
	$(this).addClass('empty');
	$('#variant_'+id[1]+'_'+$('#'+id.join('_')).val()).parent().show();
	$('#'+id.join('_')).val('');
}
function dropProps(cid){
	var props = {
		accept:'div[id^="variant'+cid+'"]',
		drop:function(ev,ui){
			var id = getID(this);
			$(this).removeClass('overslot');
			if ($(this).attr('class').indexOf('empty')!=-1){
				$(this).removeClass('empty');
				$(this).addClass('filled');
			} else {
				$('#variant_'+id[1]+'_'+$('#'+id.join('_')).val()).parent().show();
			}
			$(this).empty().append(ui.draggable.html()).click(discardChoice);
			ui.draggable.parent().hide();
			$('#'+id.join('_')).val(getID(ui.draggable)[2]);
		},
		tolerance:'pointer',
		over:function(){$(this).addClass('overslot');},
		out:function(){$(this).removeClass('overslot');}
	};
	return props;
};